gtkmm: Gtk::EventControllerMotion Class Reference

gtkmm 4.10.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::EventControllerMotion Class Reference
Event Controllers and Gestures

Event controller for motion events. More...

`#include <gtkmm/eventcontrollermotion.h>`

Inheritance diagram for Gtk::EventControllerMotion:
[legend]

## Public Member Functions
| EventControllerMotion (EventControllerMotion && src) noexcept
EventControllerMotion & | operator= (EventControllerMotion && src) noexcept
| ~EventControllerMotion () noexcept override
GtkEventControllerMotion * | gobj ()
| Provides access to the underlying C GObject.
const GtkEventControllerMotion * | gobj () const
| Provides access to the underlying C GObject.
GtkEventControllerMotion * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
bool | contains_pointer () const
| Returns if a pointer is within self or one of its children.
bool | is_pointer () const
| Returns if a pointer is within self, but not one of its children.
Glib::SignalProxy< void(double, double)> | signal_enter ()
Glib::SignalProxy< void()> | signal_leave ()
Glib::SignalProxy< void(double, double)> | signal_motion ()
Glib::PropertyProxy_ReadOnly< bool > | property_is_pointer () const
| Whether the pointer is in the controllers widget itself, as opposed to in a descendent widget.
Glib::PropertyProxy_ReadOnly< bool > | property_contains_pointer () const
| Whether the pointer is in the controllers widget or a descendant.
Public Member Functions inherited from Gtk::EventController
| EventController (EventController && src) noexcept
EventController & | operator= (EventController && src) noexcept
| ~EventController () noexcept override
GtkEventController * | gobj ()
| Provides access to the underlying C GObject.
const GtkEventController * | gobj () const
| Provides access to the underlying C GObject.
GtkEventController * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Widget * | get_widget ()
| Returns the `Gtk::Widget` this controller relates to.
const Widget * | get_widget () const
| Returns the `Gtk::Widget` this controller relates to.
void | reset ()
| Resets the controller to a clean state.
PropagationPhase | get_propagation_phase () const
| Gets the propagation phase at which controller handles events.
void | set_propagation_phase (PropagationPhase phase)
| Sets the propagation phase at which a controller handles events.
PropagationLimit | get_propagation_limit () const
| Gets the propagation limit of the event controller.
void | set_propagation_limit (PropagationLimit limit)
| Sets the event propagation limit on the event controller.
Glib::ustring | get_name () const
| Gets the name of controller.
void | set_name (const Glib::ustring & name)
| Sets a name on the controller that can be used for debugging.
Glib::RefPtr< const Gdk::Event > | get_current_event () const
| Returns the event that is currently being handled by the controller.
guint32 | get_current_event_time () const
| Returns the timestamp of the event that is currently being handled by the controller.
Glib::RefPtr< Gdk::Device > | get_current_event_device ()
| Returns the device of the event that is currently being handled by the controller.
Glib::RefPtr< const Gdk::Device > | get_current_event_device () const
| Returns the event that is currently being handled by the controller.
Gdk::ModifierType | get_current_event_state () const
| Returns the modifier state of the event that is currently being handled by the controller.
Glib::PropertyProxy_ReadOnly< Widget * > | property_widget () const
| The widget receiving the `Gdk::Events` that the controller will handle.
Glib::PropertyProxy< PropagationPhase > | property_propagation_phase ()
| The propagation phase at which this controller will handle events.
Glib::PropertyProxy_ReadOnly< PropagationPhase > | property_propagation_phase () const
| The propagation phase at which this controller will handle events.
Glib::PropertyProxy< PropagationLimit > | property_propagation_limit ()
| The limit for which events this controller will handle.
Glib::PropertyProxy_ReadOnly< PropagationLimit > | property_propagation_limit () const
| The limit for which events this controller will handle.
Glib::PropertyProxy< Glib::ustring > | property_name ()
| The name for this controller, typically used for debugging purposes.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_name () const
| The name for this controller, typically used for debugging purposes.
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< EventControllerMotion > | create ()
Static Public Member Functions inherited from Gtk::EventController
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Protected Member Functions
| EventControllerMotion ()
Protected Member Functions inherited from Gtk::EventController
| EventController ()
| There is no create() method that corresponds to this constructor, because only derived classes shall be created.
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::EventControllerMotion > | wrap (GtkEventControllerMotion * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Functions inherited from Gtk::EventController
Glib::RefPtr< Gtk::EventController > | wrap (GtkEventController * object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)

## Detailed Description

Event controller for motion events.

Gtk::EventControllerMotion is an event controller meant for situations where you need to track the position of the pointer.

Since gtkmm 3.94:

## Constructor & Destructor Documentation

## ◆ EventControllerMotion() [1/2]

Gtk::EventControllerMotion::EventControllerMotion | ( | EventControllerMotion && | src | ) |
| noexcept

## ◆ ~EventControllerMotion()

Gtk::EventControllerMotion::~EventControllerMotion | ( |  | ) |
| overridenoexcept

## ◆ EventControllerMotion() [2/2]

Gtk::EventControllerMotion::EventControllerMotion | ( |  | ) |
| protected

## Member Function Documentation

## ◆ contains_pointer()

bool Gtk::EventControllerMotion::contains_pointer | ( |  | ) | const

Returns if a pointer is within self or one of its children.

Returns
  `true` if a pointer is within self or one of its children.

## ◆ create()

static Glib::RefPtr< EventControllerMotion > Gtk::EventControllerMotion::create | ( |  | ) |
| static

## ◆ get_type()

static GType Gtk::EventControllerMotion::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkEventControllerMotion * Gtk::EventControllerMotion::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkEventControllerMotion * Gtk::EventControllerMotion::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GtkEventControllerMotion * Gtk::EventControllerMotion::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ is_pointer()

bool Gtk::EventControllerMotion::is_pointer | ( |  | ) | const

Returns if a pointer is within self, but not one of its children.

Returns
  `true` if a pointer is within self but not one of its children.

## ◆ operator=()

EventControllerMotion & Gtk::EventControllerMotion::operator= | ( | EventControllerMotion && | src | ) |
| noexcept

## ◆ property_contains_pointer()

Glib::PropertyProxy_ReadOnly< bool > Gtk::EventControllerMotion::property_contains_pointer | ( |  | ) | const

Whether the pointer is in the controllers widget or a descendant.

See also property_is_pointer().

When handling crossing events, this property is updated before signal_enter(), but after signal_leave() is emitted.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_is_pointer()

Glib::PropertyProxy_ReadOnly< bool > Gtk::EventControllerMotion::property_is_pointer | ( |  | ) | const

Whether the pointer is in the controllers widget itself, as opposed to in a descendent widget.

See also property_contains_pointer().

When handling crossing events, this property is updated before signal_enter(), but after signal_leave() is emitted.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ signal_enter()

Glib::SignalProxy< void(double, double)> Gtk::EventControllerMotion::signal_enter | ( |  | ) |

Slot Prototype:
  `void on_my_enter(double x, double y)`

Flags: Run Last

Signals that the pointer has entered the widget.

Parameters

  x | Coordinates of pointer location.
  y | Coordinates of pointer location.

## ◆ signal_leave()

Glib::SignalProxy< void()> Gtk::EventControllerMotion::signal_leave | ( |  | ) |

Slot Prototype:
  `void on_my_leave()`

Flags: Run Last

Signals that the pointer has left the widget.

## ◆ signal_motion()

Glib::SignalProxy< void(double, double)> Gtk::EventControllerMotion::signal_motion | ( |  | ) |

Slot Prototype:
  `void on_my_motion(double x, double y)`

Flags: Run First

Emitted when the pointer moves inside the widget.

Parameters

  x | The x coordinate.
  y | The y coordinate.

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::EventControllerMotion > wrap | ( | GtkEventControllerMotion * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.